package com.mortals.xhx.module.device.web;

import com.mortals.framework.exception.AppException;
import com.mortals.framework.model.Context;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.base.system.param.service.ParamService;
import com.mortals.xhx.module.device.model.DeviceMessageStatEntity;
import com.mortals.xhx.module.device.service.DeviceMessageStatService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.ObjectUtils;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * 设备消息统计
 *
 * @author zxfei
 * @date 2024-03-26
 */
@RestController
@RequestMapping("device/message/stat")
public class DeviceMessageStatController extends BaseCRUDJsonBodyMappingController<DeviceMessageStatService, DeviceMessageStatEntity, Long> {

    @Autowired
    private ParamService paramService;

    public DeviceMessageStatController() {
        super.setModuleDesc("设备消息统计");
    }


    @Override
    protected void init(Map<String, Object> model, Context context) {
        super.init(model, context);
    }


    @Override
    protected int doListAfter(DeviceMessageStatEntity query, Map<String, Object> model, Context context) throws AppException {
        List<DeviceMessageStatEntity> statEntities = (List<DeviceMessageStatEntity>) model.get(KEY_RESULT_DATA);
        //重新分组返回  [{date:2024-8}]
        if(!ObjectUtils.isEmpty(statEntities)){
            //按月分组
            Map<Integer, Map<String, List<DeviceMessageStatEntity>>> collect = statEntities.stream().collect(Collectors.groupingBy(DeviceMessageStatEntity::getMonth, Collectors.groupingBy(DeviceMessageStatEntity::getProductCode)));
            model.put("stat", collect);
        }
        return super.doListAfter(query, model, context);
    }
}